import { useLayoutEffect, useRef, useState } from 'react';

var useRefs = function useRefs() {
  var refs = useRef(new Set());

  var _useState = useState(0),
      steps = _useState[0],
      setSteps = _useState[1];

  var useContextRef = function useContextRef(node) {
    if (node === null) return;

    if (refs.current.has(node)) {
      refs.current["delete"](node);
    }

    refs.current.add(node);
    setSteps(refs.current.size);
  };

  var useContextUnRef = function useContextUnRef(ref) {
    return useLayoutEffect(function () {
      return function () {
        refs.current["delete"](ref.current);
        setSteps(refs.current.size);
      };
    }, [ref]);
  };

  return {
    useContextRef: useContextRef,
    useContextUnRef: useContextUnRef,
    steps: steps
  };
};

export default useRefs;